DROP PROCEDURE IF EXISTS user_login;
DELIMITER $$
CREATE PROCEDURE `user_login` (IN i_username VARCHAR(50), IN i_password VARCHAR(50))
BEGIN
   DROP TABLE IF EXISTS UserLogin;
    CREATE TABLE UserLogin
      SELECT username, status, isCustomer, isAdmin, isManager
      from users
      inner join userloginview on username = un
    WHERE 
       (users.username = i_username) AND (password = md5(i_password));
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS manager_only_register;
DELIMITER $$
CREATE PROCEDURE `manager_only_register` (IN i_username VARCHAR(50), IN i_password VARCHAR(50), IN i_firstname VARCHAR(50), IN i_lastname VARCHAR(50), IN i_comName VARCHAR(50), IN i_empStreet VARCHAR(50), IN i_empCity VARCHAR(50), IN i_empState CHAR(2), IN i_empZipcode CHAR(5))
BEGIN
INSERT INTO users (username, password, firstname, lastname, userType, status)
VALUES (i_username, MD5(i_password), i_firstname, i_lastname, 'Manager', 'Pending');
INSERT INTO employee (username, manStreet, manCity, manState, manZipcode, employeeType, comName) VALUES (i_username, i_empStreet, i_empCity, i_empState, i_empZipcode, 'Manager', i_comName); 
END$$
DELIMITER ;



DROP PROCEDURE IF EXISTS customer_add_creditcard;
DELIMITER $$
CREATE PROCEDURE `customer_add_creditcard` (IN i_username VARCHAR(50), IN i_creditCardNum CHAR(16))
BEGIN
IF 5 > (select count(creditCardNum) from customercreditcard where i_username = username)
THEN
IF 1 = (select isCustomer from userloginview where un = i_username)
	AND LENGTH(i_creditCardNum) = 16
THEN
    INSERT INTO customercreditcard (creditCardNum, username)
    VALUES (i_creditCardNum, i_username);
END IF;
END IF;
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS customer_only_register; 
DELIMITER $$
CREATE PROCEDURE `customer_only_register` (IN i_username VARCHAR(50), IN i_password VARCHAR(50), IN i_firstname VARCHAR(50), IN i_lastname VARCHAR(50))
BEGIN
   INSERT INTO users (username, password, firstname, lastname, userType, status) VALUES (i_username, MD5(i_password), i_firstname, i_lastname, 'Customer', 'Pending');
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS admin_approve_user;
DELIMITER $$
CREATE PROCEDURE `admin_approve_user` (IN i_username VARCHAR(50))

BEGIN
DECLARE user_status enum('Approved', 'Declined', 'Pending');
SELECT status into user_status from users where username = i_username;
IF user_status = 'Pending' OR user_status = 'Declined'
THEN
UPDATE `users`
SET `status` = 'Approved'
WHERE username = i_username;
END IF;
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS admin_decline_user;
DELIMITER $$
CREATE PROCEDURE `admin_decline_user` (IN i_username VARCHAR(50))
BEGIN
DECLARE user_status enum('Approved', 'Declined', 'Pending');
SELECT status into user_status from users where username = i_username;
IF user_status = 'Pending'
THEN
UPDATE `users`
SET `status` = 'Declined'
WHERE username = i_username;
END IF;
END$$
DELIMITER ;



DROP PROCEDURE IF EXISTS admin_filter_user;
DELIMITER $$
CREATE PROCEDURE `admin_filter_user` (IN i_username VARCHAR(50), IN i_status ENUM ('Approved', 'Pending', 'Declined', 'ALL'), IN i_sortBy ENUM('username', 'creditCardCount', 'userType', 'status', '') , IN i_sortDirection  ENUM('DESC', 'ASC', ''))

BEGIN

DROP TABLE IF EXISTS AdFilterUser;
IF (i_sortDirection = 'ASC')
THEN

CREATE TABLE AdFilterUser AS
(SELECT username, 0 AS creditCardCount, userType, status
FROM Users
WHERE (i_status = '' OR i_status = 'ALL' OR i_status IS null OR i_status = status) AND
(i_username = '' OR i_username = 'ALL' OR i_username IS null OR i_username = username) AND
(username NOT IN (SELECT username from Users NATURAL JOIN customercreditcard))
)
UNION
(SELECT username, count(*) AS creditCardCount, userType, status
FROM Users NATURAL JOIN customercreditcard
WHERE (i_status = '' OR i_status = 'ALL' OR i_status IS NULL OR i_status = status) AND
(i_username = '' OR i_username = 'ALL' OR i_username IS null OR i_username = username) AND
(username IN (SELECT username from Users NATURAL JOIN customercreditcard))
GROUP BY `username`)
ORDER BY 
CASE 
	WHEN i_sortBy = 'username'  THEN username
    WHEN i_sortBy = 'creditCardCount'  THEN creditCardCount
    WHEN i_sortBy = 'userType'  THEN userType
    WHEN i_sortBy = 'status'  THEN status
    WHEN i_sortBy IS NULL OR i_sortBy = '' THEN username
END ASC;

ELSE

CREATE TABLE AdFilterUser AS
(SELECT username, 0 AS creditCardCount, userType, status
FROM Users
WHERE (i_status = '' OR i_status = 'ALL' OR i_status IS null OR i_status = status) AND
(i_username = '' OR i_username = 'ALL' OR i_username IS null OR i_username = username) AND
(username NOT IN (SELECT username from Users NATURAL JOIN customercreditcard))
)
UNION
(SELECT username, count(*) AS creditCardCount, userType, status
FROM Users NATURAL JOIN customercreditcard
WHERE (i_status = '' OR i_status = 'ALL' OR i_status IS null OR i_status = status) AND
(i_username = '' OR i_username = 'ALL' OR i_username IS null OR i_username = username) AND
(username IN (SELECT username from Users NATURAL JOIN customercreditcard))
GROUP BY `username`)
ORDER BY 
CASE 
	WHEN i_sortBy = 'username'  THEN username
    WHEN i_sortBy = 'creditCardCount'  THEN creditCardCount
    WHEN i_sortBy = 'userType'  THEN userType
    WHEN i_sortBy = 'status'  THEN status
    WHEN i_sortBy IS NULL OR i_sortBy = '' THEN username
END DESC;
END IF;

END$$
DELIMITER ;





DROP PROCEDURE IF EXISTS `manager_schedule_mov`;
DELIMITER $$
CREATE PROCEDURE `manager_schedule_mov` (IN i_manUsername VARCHAR(50), IN i_movName VARCHAR(50), IN i_movReleaseDate DATE, IN i_movPlayDate DATE)
BEGIN


DECLARE theaterName VARCHAR(50);
DECLARE companyName VARCHAR(50);
SELECT thName INTO theaterName from employee WHERE i_manUsername = username;
SELECT comName INTO companyName from employee WHERE i_manUsername = username;


IF ((theaterName, companyName) IN (SELECT thName, comName FROM theater))
	AND
    ((i_movName,i_movReleaseDate) IN 
		(SELECT movName, movReleaseDate FROM movie))
	AND (i_movReleaseDate <= i_movPlayDate)
THEN

     INSERT INTO movieplay (movName, movReleaseDate, movPlayDate, thName, comName) VALUES (i_movName, i_movReleaseDate, i_movPlayDate, theaterName, companyName);

END IF;
END$$
DELIMITER ;




DROP PROCEDURE IF EXISTS `customer_filter_mov`;
DELIMITER $$
CREATE PROCEDURE `customer_filter_mov` (IN i_movname VARCHAR(50), IN i_comName VARCHAR(50), IN i_city VARCHAR(50), IN i_state CHAR(3), IN i_minMovPlayDate DATE, IN i_maxMovPlayDate DATE)
BEGIN
    DROP TABLE IF EXISTS CosFilterMovie;
    DROP TABLE IF EXISTS CosFilterMov;
    CREATE TABLE CosFilterMovie
        SELECT movName, thName, thStreet, thCity, thState, thZipcode, comName, movPlayDate, movReleaseDate
    FROM theater NATURAL JOIN movieplay
    WHERE
            (movName = i_movname OR i_movname = 'ALL' OR i_movname = '') AND
            (comName = i_comName OR i_comName = 'ALL' OR i_comName = '') AND
        (thCity = i_city OR i_city = 'ALL' OR i_city = '') AND
        (thState = i_state OR i_state = 'ALL' OR i_state = '') AND
        (i_minMovPlayDate IS NULL OR movPlayDate >=     
i_minMovPlayDate) AND (i_maxMovPlayDate IS NULL OR
movPlayDate <= i_maxMovPlayDate);
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS `customer_view_mov`;
DELIMITER $$
CREATE PROCEDURE `customer_view_mov`(IN i_creditCardNum CHAR(16), IN i_movName VARCHAR(50), IN i_movReleaseDate DATE,
 IN i_thName VARCHAR(50), IN i_comName VARCHAR(50), IN i_movPlayDate DATE)
BEGIN
IF (i_creditCardNum IN (SELECT creditCardNum FROM customercreditcard))
	AND
    ((i_movName, i_movReleaseDate ,i_thName, i_comName, i_movPlayDate) IN 
		(SELECT movName, movReleaseDate, thName, comName, movPlayDate FROM movieplay))
THEN
    INSERT INTO customerviewmovie(CreditCardNum, movPlayDate, movName, movReleaseDate, thName, comName)
	VALUES (i_creditCardNum, i_movPlayDate, i_movName,
	i_movReleaseDate, i_thName, i_comName);

END IF;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS `customer_view_history`;
DELIMITER $$
CREATE PROCEDURE `customer_view_history`(IN i_cusUsername VARCHAR(50))
BEGIN
    DROP TABLE IF EXISTS CosViewHistory;
    CREATE TABLE CosViewHistory
        SELECT movName, thName, comName,
CreditCardNum, movPlayDate
FROM customerviewmovie
WHERE CreditCardNum IN (SELECT creditCardNum from CustomerCreditCard WHERE i_cusUsername = username);
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS manager_customer_register;
DELIMITER $$
CREATE PROCEDURE `manager_customer_register`(IN i_username VARCHAR(50), IN i_password
VARCHAR(50), IN i_firstname VARCHAR(50), IN i_lastname VARCHAR(50),
IN i_comName VARCHAR(50), IN i_empStreet VARCHAR(50), IN i_empCity VARCHAR(50), IN i_empState CHAR(2), IN i_empZipcode CHAR(5))
BEGIN
INSERT INTO users (username, password, firstname, lastname, userType, status)
VALUES (i_username, MD5(i_password), i_firstname, i_lastname, 'CustomerManager', 'Pending');
INSERT INTO employee (username, comName, manStreet, manCity, manState, manZipcode, employeeType) 
VALUES (i_username, i_comName, i_empStreet, i_empCity, i_empState, i_empZipcode, 'Manager');
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS manager_customer_add_creditcard;
DELIMITER $$
CREATE PROCEDURE `manager_customer_add_creditcard`(IN i_username VARCHAR(50), IN i_creditCardNum CHAR(16))
BEGIN
IF 5 > (select count(creditCardNum) from customercreditcard where i_username = username)
	AND LENGTH(i_creditCardNum) = 16
THEN

INSERT INTO customercreditcard (creditCardNum, username)
VALUES (i_creditCardNum, i_username);

END IF;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS admin_filter_company;
DELIMITER $$
CREATE PROCEDURE `admin_filter_company`(IN i_comName VARCHAR(50), IN i_minCity INT, 
IN i_maxCity INT, IN i_minTheater INT, IN i_maxTheater INT, IN i_minEmployee INT, IN i_maxEmployee INT, 
i_sortBy ENUM('comName', 'numCityCover', 'numTheater', 'numEmployee', ''), i_sortDirection ENUM('DESC', 'ASC', ''))
BEGIN
DROP TABLE IF EXISTS AdFilterCom;
CREATE TABLE AdFilterCom AS
SELECT comName, numCityCover, numTheater, numEmployee
FROM
(SELECT comName, count(*) as numEmployee
FROM company NATURAL JOIN employee
WHERE (comName != '' AND (comName = i_comName OR i_comName = 'ALL'OR i_comName = ''))
GROUP BY comName) as t1
NATURAL JOIN
(SELECT comName, COUNT(DISTINCT thName) as numTheater, COUNT(DISTINCT thCity) as numCityCover
FROM Company NATURAL JOIN Theater
GROUP BY comName) as t2
WHERE (comName != '' AND (comName = i_comName OR i_comName = 'ALL'OR i_comName = ''))
HAVING
((i_minCity IS NULL AND i_maxCity IS NULL) OR (i_minCity IS NULL AND numCityCover <= i_maxCity) OR
(i_maxCity IS NULL AND i_minCity <= numCityCover) OR numCityCover BETWEEN i_minCity and i_maxCity)
AND
((i_minTheater IS NULL AND i_maxTheater IS NULL) OR (i_minTheater IS NULL AND numTheater <= i_maxTheater) OR
(i_maxTheater IS NULL AND i_minTheater <= numTheater) OR numTheater BETWEEN i_minTheater and i_maxTheater)
AND
((i_minEmployee IS NULL AND i_maxEmployee IS NULL) OR (i_minEmployee IS NULL AND numEmployee <= i_maxEmployee) OR
(i_maxEmployee IS NULL AND i_minEmployee <= numEmployee) OR numEmployee BETWEEN i_minEmployee and i_maxEmployee)
ORDER BY 
case when (i_sortBy = 'comName' or i_sortBy = '') and (i_sortDirection = 'DESC' or i_sortDirection = '') then comName END DESC,
case when (i_sortBy = 'comName' or i_sortBy = '') and i_sortDirection = 'ASC' then comName END ASC,
case when i_sortBy = 'numCityCover' and (i_sortDirection = 'DESC' or i_sortDirection = '') then numCityCover END DESC,
case when i_sortBy = 'numCityCover' and i_sortDirection = 'ASC' then numCityCover END ASC,
case when i_sortBy = 'numTheater' and (i_sortDirection = 'DESC' or i_sortDirection = '')  then numTheater END DESC,
case when i_sortBy = 'numTheater' and i_sortDirection = 'ASC' then numTheater END ASC,
case when i_sortBy = 'numEmployee' and (i_sortDirection = 'DESC' or i_sortDirection = '') then numEmployee END DESC,
case when i_sortBy = 'numEmployee' and i_sortDirection = 'ASC' then numEmployee END ASC;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS admin_create_theater;
DELIMITER $$
CREATE PROCEDURE `admin_create_theater`(IN i_thName VARCHAR(50), IN i_comName VARCHAR(50), IN i_thStreet VARCHAR(50),
IN i_thCity VARCHAR(50), IN i_thState CHAR(2), IN i_thZipcode CHAR(5), 
IN i_capacity INT(3), IN i_managerUsername VARCHAR(50))
BEGIN

IF i_comName = (select comName from employee where username = i_managerUsername)
THEN

INSERT INTO theater (comName , thName , capacity , thStreet , thCity , thState , thZipcode)
VALUES (i_comName, i_thName, i_capacity, i_thStreet, i_thCity, i_thState,i_thZipcode);

UPDATE employee
SET thName = i_thName
where username = i_managerUsername;

END IF;
END$$
DELIMITER ;











DROP PROCEDURE IF EXISTS admin_create_mov;
DELIMITER $$
CREATE PROCEDURE admin_create_mov (IN i_movName VARCHAR(50), i_movDuration INT, i_movReleaseDate DATE)
BEGIN


    INSERT INTO movie(movName, Duration, movReleaseDate)
    VALUES(i_movName, i_movDuration, i_movReleaseDate);
    
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS admin_view_comDetail_emp;
DELIMITER $$
CREATE PROCEDURE admin_view_comDetail_emp (IN i_comName VARCHAR(50))
BEGIN
 DROP TABLE IF EXISTS AdComDetailEmp;
    CREATE TABLE AdComDetailEmp
        SELECT FirstName AS empFirstname, LastName AS empLastName
         FROM employee
         INNER JOIN users
         on employee.Username = users.Username
         WHERE i_comName = employee.comName AND employeeType = 'Manager';

END $$
DELIMITER ;


DROP PROCEDURE IF EXISTS admin_view_comDetail_th;
DELIMITER $$
CREATE PROCEDURE admin_view_comDetail_th (IN i_comName VARCHAR(50))

BEGIN
    DROP TABLE IF EXISTS AdComDetailTh;
    CREATE TABLE AdComDetailTh
    SELECT distinct theater.thName, employee.username AS thManagerUserName, theater.thCity, theater.thState, theater.Capacity AS thCapacity
    FROM theater
 Inner Join employee
 on (theater.thName = employee.thName AND theater.comName = employee.comName)
 Where i_comName = theater.comName and employee.employeeType = 'Manager';
END$$
DELIMITER ;


DROP PROCEDURE IF EXISTS manager_filter_th;
DELIMITER $$
CREATE PROCEDURE  manager_filter_th (IN i_manUsername VARCHAR(50), i_movName VARCHAR(50), i_minMovDuration INT, i_maxMovDuration INT, i_minMovReleaseDate DATE, i_maxMovReleaseDate DATE, i_minMovPlayDate DATE,  i_maxMovPlayDate DATE, i_includeNotPlayed BOOLEAN)
BEGIN
DROP TABLE IF EXISTS ManFilterTh;
CREATE TABLE ManFilterTh AS
    (SELECT movie.movName, movie.Duration as movDuration, movie.movReleaseDate, movieplay.movPlayDate
    FROM (employee
                JOIN movieplay
                on (employee.thName = movieplay.thName AND employee.comName = movieplay.comName)
                JOIN movie
                on (movieplay.movName = movie.movName AND movieplay.movReleaseDate = movie.movReleaseDate))
    WHERE    
(CASE i_includeNotPlayed 
	WHEN true Then
	employee.employeeType = 'Manager' and (employee.username = i_manUsername) and (i_movName = movieplay.movName) and ((movie.Duration >= i_minMovDuration OR i_minMovDuration IS NULL) and (movie.Duration <= i_maxMovDuration OR i_maxMovDuration IS NULL)) and ((movieplay.movReleaseDate >= i_minMovReleaseDate OR i_minMovReleaseDate IS NULL) and (movieplay.movReleaseDate <= i_maxMovReleaseDate OR i_maxMovReleaseDate IS NULL)) and movieplay.movPlayDate is NULL
     
	ELSE
	employee.employeeType = 'Manager' and (employee.username = i_manUsername)
	and (i_movName = movieplay.movName OR i_movName = '' OR i_movName IS NULL)
	and ((movie.Duration >= i_minMovDuration OR i_minMovDuration IS NULL) and (movie.Duration <= i_maxMovDuration OR i_maxMovDuration IS NULL))
	and ((movieplay.movReleaseDate >= i_minMovReleaseDate OR i_minMovReleaseDate IS NULL) and (movieplay.movReleaseDate <= i_maxMovReleaseDate OR i_maxMovReleaseDate IS NULL))
	and (movieplay.movPlayDate is NULL 
	or ((movieplay.movPlayDate >= i_minMovPlayDate OR i_minMovPlayDate IS NULL) and (movieplay.movPlayDate <= i_maxMovPlayDate OR i_maxMovPlayDate IS NULL)))

END)
)
UNION
(SELECT movie.movName, movie.Duration as movDuration, movie.movReleaseDate, NULL
FROM movie
WHERE (movName, movReleaseDate) NOT IN 
	(SELECT movName, movReleaseDate FROM employee JOIN movieplay
		ON (employee.thName = movieplay.thName AND employee.comName = movieplay.comName)
        WHERE employee.username = i_manUsername
	)
	and (i_movName = movie.movName OR i_movName = '' OR i_movName IS NULL)
	and ((movie.Duration >= i_minMovDuration OR i_minMovDuration IS NULL) and (movie.Duration <= i_maxMovDuration OR i_maxMovDuration IS NULL))
	and ((movie.movReleaseDate >= i_minMovReleaseDate OR i_minMovReleaseDate IS NULL) and (movie.movReleaseDate <= i_maxMovReleaseDate OR i_maxMovReleaseDate IS NULL))
);


END $$
DELIMITER ;










 -- Provided Stored Procedures




DROP PROCEDURE IF EXISTS user_register;
DELIMITER $$
CREATE PROCEDURE `user_register`(IN i_username VARCHAR(50), IN i_password VARCHAR(50), IN i_firstname VARCHAR(50), IN i_lastname VARCHAR(50))
BEGIN
		INSERT INTO users (username, password, firstname, lastname) VALUES (i_username, MD5(i_password), i_firstname, i_lastname);
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS user_filter_th;
DELIMITER $$
CREATE PROCEDURE `user_filter_th`(IN i_thName VARCHAR(50), IN i_comName VARCHAR(50), IN i_city VARCHAR(50), IN i_state VARCHAR(3))
BEGIN
    DROP TABLE IF EXISTS UserFilterTh;
    CREATE TABLE UserFilterTh
	SELECT thName, thStreet, thCity, thState, thZipcode, comName 
    FROM Theater
    WHERE 
		(thName = i_thName OR i_thName = "ALL") AND
        (comName = i_comName OR i_comName = "ALL") AND
        (thCity = i_city OR i_city = "") AND
        (thState = i_state OR i_state = "ALL" OR i_state = '');
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS user_visit_th;
DELIMITER $$
CREATE PROCEDURE `user_visit_th`(IN i_thName VARCHAR(50), IN i_comName VARCHAR(50), IN i_visitDate DATE, IN i_username VARCHAR(50))
BEGIN
    INSERT INTO UserVisitTheater (thName, comName, visitDate, username)
    VALUES (i_thName, i_comName, i_visitDate, i_username);
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS user_filter_visitHistory;
DELIMITER $$
CREATE PROCEDURE `user_filter_visitHistory`(IN i_username VARCHAR(50), IN i_minVisitDate DATE, IN i_maxVisitDate DATE)
BEGIN
    DROP TABLE IF EXISTS UserVisitHistory;
    CREATE TABLE UserVisitHistory
	SELECT thName, thStreet, thCity, thState, thZipcode, comName, visitDate
    FROM UserVisitTheater
		NATURAL JOIN
        Theater
	WHERE
		(username = i_username) AND
        (i_minVisitDate IS NULL OR visitDate >= i_minVisitDate) AND
        (i_maxVisitDate IS NULL OR visitDate <= i_maxVisitDate);
END$$
DELIMITER ;